import { ModelConditionUtil, ModelConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, BasicFieldUtil, JoinTable, SubTable } from 'model-util';
import { BMVersion } from './BMVersion';
/**
 * @author Keytop midend auto generate
 * @version 1.0
 * @date 2020-06-02 09:56
 */
interface BMModelProject {
    /**
    * 应用ID
    * @type { string }
    */
    appId?: string;
    /**
    * 代码
    * @type { string }
    */
    code?: string;
    /**
    * 创建时间
    * @type { Date }
    */
    createTime?: Date;
    /**
    * 创建人ID
    * @type { string }
    */
    createUserId?: string;
    /**
    * 描述
    * @type { string }
    */
    description?: string;
    /**
    * 主键
    * @type { string }
    */
    id?: string;
    /**
    * 包名
    * @type { string }
    */
    packageName?: string;
    /**
    * 微服务项目ID
    * @type { string }
    */
    pid?: string;
    /**
    * 服务中心ID
    * @type { string }
    */
    serviceCenterId?: string;
    /**
    * 更新时间
    * @type { Date }
    */
    updateTime?: Date;
    /**
    * 修改人ID
    * @type { string }
    */
    updateUserId?: string;
    /**
    * 子表 BMVersion
    * @type { BMVersion[] }
    */
    bMVersion: BMVersion[];
    /**
    * extend field in SysUser
    * 姓名
    * @type { string }
    */
    createUser?: string;
    /**
    * extend field in SysUser
    * 姓名
    * @type { string }
    */
    updateUser?: string;
}
interface BMModelProjectMCU extends ModelConditionUtil<BMModelProjectMCU> {
    APP_ID: FieldUtil<BMModelProjectMCU>;
    CODE: FieldUtil<BMModelProjectMCU>;
    CREATE_TIME: FieldUtil<BMModelProjectMCU>;
    CREATE_USER_ID: FieldUtil<BMModelProjectMCU>;
    DESCRIPTION: FieldUtil<BMModelProjectMCU>;
    ID: FieldUtil<BMModelProjectMCU>;
    PACKAGE_NAME: FieldUtil<BMModelProjectMCU>;
    PID: FieldUtil<BMModelProjectMCU>;
    SERVICE_CENTER_ID: FieldUtil<BMModelProjectMCU>;
    UPDATE_TIME: FieldUtil<BMModelProjectMCU>;
    UPDATE_USER_ID: FieldUtil<BMModelProjectMCU>;
}
declare class BMModelProjectMCUImpl extends ModelConditionUtilImpl<BMModelProjectMCUImpl> implements BMModelProjectMCU {
    newInstance(): BMModelProjectMCUImpl;
    get APP_ID(): FieldUtil<BMModelProjectMCU>;
    get CODE(): FieldUtil<BMModelProjectMCU>;
    get CREATE_TIME(): FieldUtil<BMModelProjectMCU>;
    get CREATE_USER_ID(): FieldUtil<BMModelProjectMCU>;
    get DESCRIPTION(): FieldUtil<BMModelProjectMCU>;
    get ID(): FieldUtil<BMModelProjectMCU>;
    get PACKAGE_NAME(): FieldUtil<BMModelProjectMCU>;
    get PID(): FieldUtil<BMModelProjectMCU>;
    get SERVICE_CENTER_ID(): FieldUtil<BMModelProjectMCU>;
    get UPDATE_TIME(): FieldUtil<BMModelProjectMCU>;
    get UPDATE_USER_ID(): FieldUtil<BMModelProjectMCU>;
    get CREATE_USER(): BasicFieldUtil;
    get UPDATE_USER(): BasicFieldUtil;
}
declare class BMModelProjectMU extends TableUtilImpl<BMModelProjectMCU, BMModelProject> {
    tableName: string;
    tableFields: string[];
    modelFields: string[];
    modelIdFields: string[];
    tableIdFields: string[];
    idType: IdType;
    joinTables: JoinTable[];
    subTables: SubTable[];
    constructor();
    createModelConditionUtil(): BMModelProjectMCU;
    static get APP_ID(): FieldUtil<BMModelProjectMCU>;
    static get CODE(): FieldUtil<BMModelProjectMCU>;
    static get CREATE_TIME(): FieldUtil<BMModelProjectMCU>;
    static get CREATE_USER_ID(): FieldUtil<BMModelProjectMCU>;
    static get DESCRIPTION(): FieldUtil<BMModelProjectMCU>;
    static get ID(): FieldUtil<BMModelProjectMCU>;
    static get PACKAGE_NAME(): FieldUtil<BMModelProjectMCU>;
    static get PID(): FieldUtil<BMModelProjectMCU>;
    static get SERVICE_CENTER_ID(): FieldUtil<BMModelProjectMCU>;
    static get UPDATE_TIME(): FieldUtil<BMModelProjectMCU>;
    static get UPDATE_USER_ID(): FieldUtil<BMModelProjectMCU>;
    static get CREATE_USER(): BasicFieldUtil;
    static get UPDATE_USER(): BasicFieldUtil;
    get APP_ID(): FieldUtil<BMModelProjectMCU>;
    get CODE(): FieldUtil<BMModelProjectMCU>;
    get CREATE_TIME(): FieldUtil<BMModelProjectMCU>;
    get CREATE_USER_ID(): FieldUtil<BMModelProjectMCU>;
    get DESCRIPTION(): FieldUtil<BMModelProjectMCU>;
    get ID(): FieldUtil<BMModelProjectMCU>;
    get PACKAGE_NAME(): FieldUtil<BMModelProjectMCU>;
    get PID(): FieldUtil<BMModelProjectMCU>;
    get SERVICE_CENTER_ID(): FieldUtil<BMModelProjectMCU>;
    get UPDATE_TIME(): FieldUtil<BMModelProjectMCU>;
    get UPDATE_USER_ID(): FieldUtil<BMModelProjectMCU>;
    get CREATE_USER(): BasicFieldUtil;
    get UPDATE_USER(): BasicFieldUtil;
}
export { BMModelProjectMCU, BMModelProjectMCUImpl, BMModelProject, BMModelProjectMU };
